#!/usr/bin/python3
# Prohledávání do hloubky ve stromu

# Načteme vstup: počet vrcholů, počet hran, pak hrany
n = int(input())
m = int(input())
sousede = [[] for _ in range(n)]
for _ in range(m):
    u, v = map(int, input().split())
    u -= 1   # Na vstupu vrcholy číslujeme od 1 do n
    v -= 1
    sousede[u].append(v)
    sousede[v].append(u)

# Rekurzivní funkce pro prohledávání, předáváme si rodiče,
# abychom do něj nešli znovu.
def dfs(v, rodic=None):
    # print('Enter:', v+1)

    for s in sousede[v]:
        if s != rodic:
            dfs(s, v)

    # print('Exit:', v+1)


dfs(0)
