#!/usr/bin/python3
# Prohledávání do hloubky v obecném grafu.

# Načteme vstup: počet vrcholů, počet hran, pak hrany
n = int(input())
m = int(input())
sousede = [[] for _ in range(n)]
for _ in range(m):
    u, v = map(int, input().split())
    u -= 1
    v -= 1
    sousede[u].append(v)
    sousede[v].append(u)

# Značíme si, kde už jsme byli
znacka = [False]*n

def dfs(v):
    # print('Enter', v+1)
    znacka[v] = True

    for s in sousede[v]:
        if not znacka[s]:
            dfs(s)

    # print('Exit', v+1)

dfs(0)
